program klatterbox;
 global
   sample0; sample1; sample2; sample3; sample4;
   sample5; sample6; sample7; sample8; sample9;
   font;
 begin      
   graph_mode=mode_8bits;
   set_mode(m320x240);
   set_fps(30,0); 
   
   load_fpg("klatter.fpg");
   font=load_fnt("klatter.fnt");   
   set_text_color(0);
   
   scan(1,0);
  end;
  
process scan(scanner,state);
 private
   l_pressed=0; r_pressed=0;
 begin
   delete_text(0);
   put_screen("klatter.fpg",1);
   if(scanner==1)
     if(file_exists("sounds\sample0.wav") and state==0)sample0=load_wav("sounds\sample0.wav");state++;end;
     if(file_exists("sounds\sample1.wav") and state==1)sample1=load_wav("sounds\sample1.wav");state++;end;
     if(file_exists("sounds\sample2.wav") and state==2)sample2=load_wav("sounds\sample2.wav");state++;end;
     if(file_exists("sounds\sample3.wav") and state==3)sample3=load_wav("sounds\sample3.wav");state++;end;
     if(file_exists("sounds\sample4.wav") and state==4)sample4=load_wav("sounds\sample4.wav");state++;end;
     if(file_exists("sounds\sample5.wav") and state==5)sample5=load_wav("sounds\sample5.wav");state++;end;
     if(file_exists("sounds\sample6.wav") and state==6)sample6=load_wav("sounds\sample6.wav");state++;end;
     if(file_exists("sounds\sample7.wav") and state==7)sample7=load_wav("sounds\sample7.wav");state++;end;
     if(file_exists("sounds\sample8.wav") and state==8)sample8=load_wav("sounds\sample8.wav");state++;end;
     if(file_exists("sounds\sample9.wav") and state==9)sample9=load_wav("sounds\sample9.wav");state++;end;
    end;
         
   loop
     if(key(_left))l_pressed=1;end;
     if(key(_right))r_pressed=1;end;
     if(not key(_left) and l_pressed==1)controlled_play(state);return;end;
     if(not key(_right) and r_pressed==1)random_play(state);return;end;   
     frame;
    end;
  end;

process controlled_play(state);
 private
   pressed=0;
   left_pressed=0; right_pressed=0; up_pressed=0; down_pressed=0;
   control_pressed=0; alt_pressed=0; space_pressed=0; 
   enter_pressed=0; tab_pressed=0; backspace_pressed=0;   
 begin
   delete_text(0);
   put_screen("klatter.fpg",2);      
   loop
     if(key(_left) and pressed==0 and state>0)left_pressed=1;pressed=1;end;
     if(not key(_left) and pressed==1 and left_pressed==1)play_wav(sample0,0);pressed=0;left_pressed=0;end;     
     if(key(_right) and pressed==0 and state>1)right_pressed=1;pressed=1;end;
     if(not key(_right) and pressed==1 and right_pressed==1)play_wav(sample1,0);pressed=0;right_pressed=0;end;     
     if(key(_up) and pressed==0 and state>2)up_pressed=1;pressed=1;end;
     if(not key(_up) and pressed==1 and up_pressed==1)play_wav(sample2,0);pressed=0;up_pressed=0;end;     
     if(key(_down) and pressed==0 and state>3)down_pressed=1;pressed=1;end;
     if(not key (_down) and pressed==1 and down_pressed==1)play_wav(sample3,0);pressed=0;down_pressed=0;end;     
     if(key(_control) and pressed==0 and state>4)control_pressed=1;pressed=1;end;
     if(not key (_control) and pressed==1 and control_pressed==1)play_wav(sample4,0);pressed=0;control_pressed=0;end;     
     if(key(_alt) and pressed==0 and state>5)alt_pressed=1;pressed=1;end;
     if(not key (_alt) and pressed==1 and alt_pressed==1)play_wav(sample5,0);pressed=0;alt_pressed=0;end;     
     if(key(_space) and pressed==0 and state>6)space_pressed=1;pressed=1;end;
     if(not key (_space) and pressed==1 and space_pressed==1)play_wav(sample6,0);pressed=0;space_pressed=0;end;     
     if(key(_enter) and pressed==0 and state>7)enter_pressed=1;pressed=1;end;
     if(not key (_enter) and pressed==1 and enter_pressed==1)play_wav(sample7,0);pressed=0;enter_pressed=0;end;     
     if(key(_tab) and pressed==0 and state>8)tab_pressed=1;pressed=1;end;
     if(not key (_tab) and pressed==1 and tab_pressed==1)play_wav(sample8,0);pressed=0;tab_pressed=0;end;     
     if(key(_backspace) and pressed==0 and state>9)backspace_pressed=1;pressed=1;end;
     if(not key (_backspace) and pressed==1 and backspace_pressed==1)play_wav(sample9,0);pressed=0;backspace_pressed=0;end;                
     
     if(key(_tab) and key(_backspace))scan(0,state);return;end;
     
     if(state==0)return;end;
     frame;
    end;
  end;

process random_play(state);
 private   
   max_chance=700; current_sample=-1; 
   string sample_name;
   l_release=0; r_release=0; s_release=0; done=0;         
   rand_0=1; rand_1=1; rand_2=1; rand_3=1; rand_4=1;
   rand_5=1; rand_6=1; rand_7=1; rand_8=1; rand_9=1;
   playing=0;
 begin   
   graph=4; y=78;
   delete_text(0);
   put_screen("klatter.fpg",3);      
   write(font,207,135,0, "1:");
   write_int(font,222,135,0, &max_chance);
   write_string(font,229,130,4, &sample_name);
   loop          
     if(not key(_control) and not key(_alt) and key(_up) and max_chance>100)max_chance--;end;
     if(not key(_control) and not key(_alt) and key(_down))max_chance++;end;
     if(key(_control) and not key(_alt) and key(_up) and max_chance>100)max_chance-=10;end;
     if(key(_control) and not key(_alt) and key(_down))max_chance+=10;end;
     if(not key(_control) and key(_alt) and key(_up) and max_chance>100)max_chance-=100;end;
     if(not key(_control) and key(_alt) and key(_down))max_chance+=100;end;          
     
     if(key(_left) and current_sample>-1)l_release=1;end;
     if(not key(_left) and l_release==1)l_release=0;current_sample--;end;
     if(key(_right) and current_sample<state-1)r_release=1;end;
     if(not key(_right) and r_release==1)r_release=0;current_sample++;end;
     
     if(key(_enter))done=0;s_release=1;end;
     if(not key(_enter) and s_release==1)
       if(playing==0 and done==0)playing=1;done=1;end;
       if(playing==1 and done==0)playing=0;done=0;end;
       s_release=0;
      end;
     
     if(key(_tab) and key(_backspace))scan(0,state);return;end;
     
     if(playing==0)x=132;end;
     if(playing==1)x=93;end;
     
     if(current_sample==-1)sample_name="All Samples";end;
     if(current_sample==0)sample_name="Only Sample 0";end;
     if(current_sample==1)sample_name="Only Sample 1";end;
     if(current_sample==2)sample_name="Only Sample 2";end;
     if(current_sample==3)sample_name="Only Sample 3";end;
     if(current_sample==4)sample_name="Only Sample 4";end;
     if(current_sample==5)sample_name="Only Sample 5";end;
     if(current_sample==6)sample_name="Only Sample 6";end;
     if(current_sample==7)sample_name="Only Sample 7";end;
     if(current_sample==8)sample_name="Only Sample 8";end;
     if(current_sample==9)sample_name="Only Sample 9";end;
                
     if(state>0)rand_0=rand(0,max_chance);end;     
     if(state>1)rand_1=rand(0,max_chance);end;
     if(state>2)rand_2=rand(0,max_chance);end;
     if(state>3)rand_3=rand(0,max_chance);end;
     if(state>4)rand_4=rand(0,max_chance);end;
     if(state>5)rand_5=rand(0,max_chance);end;
     if(state>6)rand_6=rand(0,max_chance);end;
     if(state>7)rand_7=rand(0,max_chance);end;
     if(state>8)rand_8=rand(0,max_chance);end;
     if(state>9)rand_9=rand(0,max_chance);end;
     
     if(playing==1)
       if(rand_0>(max_chance-1) and (current_sample==-1 or current_sample==0))play_wav(sample0,0);end;
       if(rand_1>(max_chance-1) and (current_sample==-1 or current_sample==1))play_wav(sample1,0);end;
       if(rand_2>(max_chance-1) and (current_sample==-1 or current_sample==2))play_wav(sample2,0);end;
       if(rand_3>(max_chance-1) and (current_sample==-1 or current_sample==3))play_wav(sample3,0);end;
       if(rand_4>(max_chance-1) and (current_sample==-1 or current_sample==4))play_wav(sample4,0);end;
       if(rand_5>(max_chance-1) and (current_sample==-1 or current_sample==5))play_wav(sample5,0);end;
       if(rand_6>(max_chance-1) and (current_sample==-1 or current_sample==6))play_wav(sample6,0);end;
       if(rand_7>(max_chance-1) and (current_sample==-1 or current_sample==7))play_wav(sample7,0);end;
       if(rand_8>(max_chance-1) and (current_sample==-1 or current_sample==8))play_wav(sample8,0);end;
       if(rand_9>(max_chance-1) and (current_sample==-1 or current_sample==9))play_wav(sample9,0);end;        
      end;
      
     if(state==0)return;end;
     frame;
    end;
  end;